About
Nano Banana 2.1 Edit by Google transforms reference images using text instructions, with output resolutions up to 4K and optional video or PDF context.
1. Calling the API
Setup your API Key
To begin using Infron, you first need to create an account and generate your API Key.
Once you have your API key, set it as an environment variable in your runtime environment. This allows your applications to securely access Infron’s API.
export INFRON_KEY="YOUR_API_KEY"
Submit a request
For long-running requests, you can poll for results.
curl https://media.onerouter.pro/v1/images/generations \
-H "Authorization: Bearer YOUR_API_KEY" \
-H "Content-Type: application/json" \
-d @- <<'EOF'
{
"model": "google/gemini-nano-banana-2.1/image-to-image",
"prompt": "make a photo of the man driving the car down the california coastline.",
"image_urls": [
"https://storage.googleapis.com/infron_gcs/quick-upload/2026/10/12/20261012-161023-1321f4ac-1.png"
],
"n": 1,
"aspect_ratio": "16:9",
"resolution": "1K",
"output_format": "png",
"enable_web_search": true,
"enable_image_search": false,
"output_format": "png",
"response_format": "url"
}
EOF
Response with queue task id
The response will look like this:
{
"code": 200,
"message": "success",
"data": {
"task_id": "20261012081156659271714f1jK554Z",
"object": "image",
"model": "google/gemini-nano-banana-2.1/image-to-image",
"status": "created",
"urls": {
"query": "https://media.onerouter.pro/v1/images/tasks/20261012081156659271714f1jK554Z"
},
"created_at": "2026-10-12 08:11:56.69"
}
}
Fetch request status
You can fetch the status of a request to check if it is completed or still in progress.
curl https://media.onerouter.pro/v1/images/tasks/{task_id} \
-H "Authorization: Bearer YOUR_API_KEY" \
-H "Content-Type: application/json"
# For example
curl https://media.onerouter.pro/v1/images/tasks/20261012081156659271714f1jK554Z \
-H "Authorization: Bearer YOUR_API_KEY" \
-H "Content-Type: application/json"
Response with queue task status query
{
"code": 200,
"message": "success",
"data": {
"task_id": "20261012081156659271714f1jK554Z",
"object": "image",
"model": "google/gemini-nano-banana-2.1/image-to-image",
"status": "in_progress",
"fail_reason": "",
"submit_time": 1791792717,
"start_time": 1791792716,
"finish_time": 0,
"outputs": [],
"created_at": "2026-10-12 08:11:57"
}
}
Possible statuses:
- created
- in_progress
- processing
- completed
- failed
created -> in_progress → processing → completed | failed
Poll every 1-2 seconds until status is "completed" or "failed"
Get the result (when status is "completed")
Once the request is completed, you can fetch the result. See the Output Schema for the expected result format.
{
"code": 200,
"message": "success",
"data": {
"task_id": "20261012081156659271714f1jK554Z",
"object": "image",
"model": "google/gemini-nano-banana-2.1/image-to-image",
"status": "completed",
"fail_reason": "",
"submit_time": 1791792717,
"start_time": 1791792716,
"finish_time": 1791792735,
"outputs": [
"https://infron.ai/cdn/media/image/gemini_1d2fb433-ac9d-4f61-be3f-bc990c87126c.png"
],
"usage": {
"completion_tokens": 2099,
"image_count": 1,
"image_quality": "",
"prompt_tokens": 1134,
"resolution": "1K",
"total_tokens": 3233,
"web_search": true
},
"cost": {
"total_cost": 0.042644,
"cost_details": {
"prompt_cost": 0,
"completion_cost": 0,
"image_cost": 0.042644,
"video_cost": 0,
"audio_cost": 0,
"native_web_search_cost": 0,
"plugin_web_search_cost": 0,
"tools_cost": 0,
"prompt_cache_read_cost": 0,
"prompt_cache_write_cost": 0,
"prompt_cache_write_5_min": 0,
"prompt_cache_write_1_h": 0,
"reasoning_cost": 0,
"discount_rate": 1,
"is_byok": false,
"byok_cost": 0
}
},
"created_at": "2026-10-12 08:11:57"
}
}
2. Schema
Input
| Parameter | Type | Required | Default | Range | Description |
|---|---|---|---|---|---|
| model | string | Yes | -- | Explore all models | Model name. |
| prompt | string | Yes | -- | -- | Text prompt for generation; Positive text prompt. |
| image_urls | array | Yes | -- | [1,14] | Image URLs. |
| n | integer | No | 1 | ==1 | Number of images to generate. |
| aspect_ratio | string | No | -- | 1:1、2:3、3:2、3:4、4:3、4:5、5:4、9:16、16:9、21:9、1:4、4:1、1:8、8:1 | Aspect ratio of the generated image. |
| resolution | string | No | 1K | 1K, 2K, 4K | Resolution of the generated image. |
| thinking_level | string | No | MEDIUM | MINIMAL, HIGH, MEDIUM | Thinking level of the model. |
| enablewebsearch | boolean | No | False | true, false | Enable web search grounding. |
| enableimagesearch | boolean | No | False | true, false | Enable image search grounding. |
| output_format | string | No | png | png, jpeg | Output format for the images. |
| response_format | string | No | url | url | URL of the generated image. |
Example request
curl https://media.onerouter.pro/v1/images/generations \
-H "Authorization: Bearer YOUR_API_KEY" \
-H "Content-Type: application/json" \
-d @- <<'EOF'
{
"model": "google/gemini-nano-banana-2.1/image-to-image",
"prompt": "make a photo of the man driving the car down the california coastline.",
"image_urls": [
"https://storage.googleapis.com/infron_gcs/quick-upload/2026/10/12/20261012-161023-1321f4ac-1.png"
],
"n": 1,
"aspect_ratio": "16:9",
"resolution": "1K",
"output_format": "png",
"enable_web_search": true,
"enable_image_search": false,
"output_format": "png",
"response_format": "url"
}
EOF
Output
| Parameter | Type | Range | Description |
|---|---|---|---|
| code | integer | -- | Status code of the request. |
| message | string | -- | Status message of the request. |
| data | object | -- | Data of the task. |
| data.task_id | string | -- | ID of the task. |
| data.object | string | -- | Object type of the task. |
| data.model | string | -- | Model name of the task. |
| data.status | string | created, in_progress, processing, completed, failed | Status of the task. |
| data.fail_reason | string | -- | Fail reason of the task. |
| data.submit_time | integer | -- | Timestamp of the task submission. |
| data.start_time | integer | -- | Timestamp of the task start. |
| data.finish_time | integer | -- | Timestamp of the task finish. |
| data.outputs | array | -- | Outputs of the task. |
| data.created_at | string | -- | Timestamp of the task creation. |
Example output
{
"code": 200,
"message": "success",
"data": {
"task_id": "20261012081156659271714f1jK554Z",
"object": "image",
"model": "google/gemini-nano-banana-2.1/image-to-image",
"status": "completed",
"fail_reason": "",
"submit_time": 1791792717,
"start_time": 1791792716,
"finish_time": 1791792735,
"outputs": [
"https://infron.ai/cdn/media/image/gemini_1d2fb433-ac9d-4f61-be3f-bc990c87126c.png"
],
"usage": {
"completion_tokens": 2099,
"image_count": 1,
"image_quality": "",
"prompt_tokens": 1134,
"resolution": "1K",
"total_tokens": 3233,
"web_search": true
},
"cost": {
"total_cost": 0.042644,
"cost_details": {
"prompt_cost": 0,
"completion_cost": 0,
"image_cost": 0.042644,
"video_cost": 0,
"audio_cost": 0,
"native_web_search_cost": 0,
"plugin_web_search_cost": 0,
"tools_cost": 0,
"prompt_cache_read_cost": 0,
"prompt_cache_write_cost": 0,
"prompt_cache_write_5_min": 0,
"prompt_cache_write_1_h": 0,
"reasoning_cost": 0,
"discount_rate": 1,
"is_byok": false,
"byok_cost": 0
}
},
"created_at": "2026-10-12 08:11:57"
}
}
3. Detailed Pricing
| Pricing Type | Unit | Price |
|---|---|---|
| Input tokens | per 1M tokens | $1.50 |
| Text and thinking output | per 1M tokens | $7.50 |
| Image output | per 1M tokens | $30.00 |
| Vertex cached input | per 1M tokens | $0.15 |
| Web and image search | per 1,000 actual queries | $14.00 |
Charges depend on actual token usage and search queries. Web and image queries are counted separately. The final amount is returned in data.cost.total_cost.